errors = {}
options = {}
macro_ops = {}
stages = {}
svcid = 53

SUCCESS = 0
WARNING = 1
ERROR = 2

def determine_severity(msgs):
    severity = SUCCESS
    if msgs and len(msgs) > 0:
        for msg in msgs:
            severity = max(severity, msg[0])
    return severity

def determine_action_severity(list):
    severity = SUCCESS
    if list and len(list) > 0:
        for action in list:
            severity = max(severity, determine_severity(action[2]))
    return severity

def get_option_from_code(code, options_table):
    index = (code >> 48) & 0xff
    return options_table.get(index, None)

def get_errornum_from_code(code):
    return (code >> 56) & 0xff
options[0] = "enabled"; enabled = 0L
APACHE_REQUIRED = (53L << 56) | (enabled << 48) | 0; errors[(53L << 56) | (enabled << 48) | 0] = 'Apache must be enabled to use subdomains.'

stages[int((0) | (53 << 16))] = 'Write service configuration'; WRCONF = int((0) | (53 << 16))

SET_DEFAULT = ((53L << 56) | (255L << 48)) | 0; errors[((53L << 56) | (255L << 48)) | 0] = "Cannot set subdomain defaults. Error: %(errnum)d - %(errstr)s"
EXISTS = ((53L << 56) | (255L << 48)) | 1; errors[((53L << 56) | (255L << 48)) | 1] = "Subdomain %(sub)s already exists"
NOIP = ((53L << 56) | (255L << 48)) | 2; errors[((53L << 56) | (255L << 48)) | 2] = "Cannot determine IP address of site"
ADD_A = ((53L << 56) | (255L << 48)) | 3; errors[((53L << 56) | (255L << 48)) | 3] = "Cannot add A record %(a)s. Error: %(errnum)d - %(errstr)s"
EOPERATION = ((53L << 56) | (255L << 48)) | 4; errors[((53L << 56) | (255L << 48)) | 4] = "Unsupported Operation %(op)s"
SCRIPTDIR_EXISTS = ((53L << 56) | (255L << 48)) | 5; errors[((53L << 56) | (255L << 48)) | 5] = "CGI script directory already exists"
SCRIPTDIR_SETUP = ((53L << 56) | (255L << 48)) | 6; errors[((53L << 56) | (255L << 48)) | 6] = "Error in setting up CGI script directory. %(errstr)s"
SCRIPTDIR_ISLINK = ((53L << 56) | (255L << 48)) | 7; errors[((53L << 56) | (255L << 48)) | 7] = "CGI script directory is a symbolic link. Original directory not removed !"
SCRIPTDIR_MISSING = ((53L << 56) | (255L << 48)) | 8; errors[((53L << 56) | (255L << 48)) | 8] = "CGI script directory does not exist."
SCRIPTDIR_UNLINK = ((53L << 56) | (255L << 48)) | 9; errors[((53L << 56) | (255L << 48)) | 9] = "Error in removing CGI script directory. %(errstr)s"
APACHEMAP_UPDATE = ((53L << 56) | (255L << 48)) | 10; errors[((53L << 56) | (255L << 48)) | 10] = "Error in updating Apache map. %(errstr)s"
NOSUB = ((53L << 56) | (255L << 48)) | 11; errors[((53L << 56) | (255L << 48)) | 11] = "Subdomain %(sub)s does not exist"
DOCROOT_SETUP = ((53L << 56) | (255L << 48)) | 12; errors[((53L << 56) | (255L << 48)) | 12] = "Error in setting up document root directory. %(errstr)s"
APACHECONF = ((53L << 56) | (255L << 48)) | 13; errors[((53L << 56) | (255L << 48)) | 13] = "Cannot write Apache configuration. %(errstr)s"
BASE_EXISTS = ((53L << 56) | (255L << 48)) | 14; errors[((53L << 56) | (255L << 48)) | 14] = "Subdomain base directory %(base)s already exists"
BASE_SETUP = ((53L << 56) | (255L << 48)) | 15; errors[((53L << 56) | (255L << 48)) | 15] = "Error setting up subdomain base directory. %(errstr)s"
EDISABLE = ((53L << 56) | (255L << 48)) | 16; errors[((53L << 56) | (255L << 48)) | 16] = "Error disabling subdomains. %(errstr)s"
BASEDIR_SETUP = ((53L << 56) | (255L << 48)) | 17; errors[((53L << 56) | (255L << 48)) | 17] = "Error in setting up subdomain base directory. %(errstr)s"
BASEDIR_REMOVE = ((53L << 56) | (255L << 48)) | 18; errors[((53L << 56) | (255L << 48)) | 18] = "Error in deleting subdomain base directory. %(errstr)s"
TOOMANY = ((53L << 56) | (255L << 48)) | 19; errors[((53L << 56) | (255L << 48)) | 19] = "No more than %(max)d subdomain(s) are allowed for this site"
INDEXHTML = ((53L << 56) | (255L << 48)) | 20; errors[((53L << 56) | (255L << 48)) | 20] = "Error setting up default homepage. %(errstr)s"
EUSER = ((53L << 56) | (255L << 48)) | 21; errors[((53L << 56) | (255L << 48)) | 21] = "User %(user)s does not exist"
ECHOWN = ((53L << 56) | (255L << 48)) | 22; errors[((53L << 56) | (255L << 48)) | 22] = "Cannot change ownership. %(errstr)s"
DELETE_A = ((53L << 56) | (255L << 48)) | 23; errors[((53L << 56) | (255L << 48)) | 23] = "Cannot delete A record %(a)s. Error: %(errnum)d - %(errstr)s"
MANUALBIND = ((53L << 56) | (255L << 48)) | 24; errors[((53L << 56) | (255L << 48)) | 24] = "You need to manually enable DNS/BIND for each subdomain of this site"
CGIRENAM = ((53L << 56) | (255L << 48)) | 25; errors[((53L << 56) | (255L << 48)) | 25] = "Error renaming CGI Script directory. %(errstr)s"
BASERENAM = ((53L << 56) | (255L << 48)) | 26; errors[((53L << 56) | (255L << 48)) | 26] = "Error renaming SubDomain base directory. %(errstr)s"
DOCROOT_EXISTS = ((53L << 56) | (255L << 48)) | 27; errors[((53L << 56) | (255L << 48)) | 27] = "Document Root %(document_root)s already exists"
INVALIDCGI = ((53L << 56) | (255L << 48)) | 28; errors[((53L << 56) | (255L << 48)) | 28] = "Invalid CGI Option selected"
OWNERMAP_INIT = ((53L << 56) | (255L << 48)) | 29; errors[((53L << 56) | (255L << 48)) | 29] = "Unable to initialize subdomain owner map"
OWNERMAP_UPDATE = ((53L << 56) | (255L << 48)) | 30; errors[((53L << 56) | (255L << 48)) | 30] = "Unable to update subdomain owner map"
DOCROOT_NOTDIR = ((53L << 56) | (255L << 48)) | 31; errors[((53L << 56) | (255L << 48)) | 31] = "Document root %(docroot)s is not a directory"
CGIEXT_REWRITE = ((53L << 56) | (255L << 48)) | 32; errors[((53L << 56) | (255L << 48)) | 32] = "Unable to rewrite CGI extension map"
INVALIDPARAM = ((53L << 56) | (255L << 48)) | 33; errors[((53L << 56) | (255L << 48)) | 33] = "Invalid %(id)s. %(err)s"
CGIMAP_UPDATE = ((53L << 56) | (255L << 48)) | 34; errors[((53L << 56) | (255L << 48)) | 34] = "Error in updating CGI map. %(errstr)s"
CGISUBMAP_UPDATE = ((53L << 56) | (255L << 48)) | 35; errors[((53L << 56) | (255L << 48)) | 35] = "Error in updating CGI subdirectory map. %(errstr)s"
SUBDOMAINALIASES = ((53L << 56) | (255L << 48)) | 36; errors[((53L << 56) | (255L << 48)) | 36] = "Subdomain aliases have also been removed"
NO_PARENT_ALIASES = ((53L << 56) | (255L << 48)) | 37; errors[((53L << 56) | (255L << 48)) | 37] = "Aliases cannot be enabled for this subdomain because the parent domain does not have aliases enabled"
NO_PARENT_BIND = ((53L << 56) | (255L << 48)) | 38; errors[((53L << 56) | (255L << 48)) | 38] = "DNS/BIND cannot be enabled for this subdomain because the parent domain does not have DNS/BIND enabled"
DOCROOT_DELETE = ((53L << 56) | (255L << 48)) | 39; errors[((53L << 56) | (255L << 48)) | 39] = "Error removing document root. %(errstr)s"
ELIMIT = ((53L << 56) | (255L << 48)) | 40; errors[((53L << 56) | (255L << 48)) | 40] = "Existing subdomain count %(old)d exceeds the newly allocated limit %(new)d"
MANUALRMBASE = ((53L << 56) | (255L << 48)) | 41; errors[((53L << 56) | (255L << 48)) | 41] = "Could not remove directory %(dir)s. Please remove it manually. %(errstr)s"
CONFLICTING_DOMAIN = ((53L << 56) | (255L << 48)) | 42; errors[((53L << 56) | (255L << 48)) | 42] = "A domain %(domain)s already exists with the same name as the subdomain!"
CONFLICTING_SUBDOMAIN = ((53L << 56) | (255L << 48)) | 43; errors[((53L << 56) | (255L << 48)) | 43] = "A subdomain %(subdomain)s already exists within the domain %(domain)s!"
CONFLICTING_WILDCARDS = ((53L << 56) | (255L << 48)) | 44; errors[((53L << 56) | (255L << 48)) | 44] = "The domain %(domain)s has subdomain wildcards enabled. %(this)s would be treated as a subdomain for that site!"
EXISTS_NOT_OWNED = ((53L << 56) | (255L << 48)) | 45; errors[((53L << 56) | (255L << 48)) | 45] = "The directory %(dir)s already exists but is not owned by %(owner)s."
SCRIPTDIR_EXISTS_NOTOWNED = ((53L << 56) | (255L << 48)) | 46; errors[((53L << 56) | (255L << 48)) | 46] = "CGI script directory %(dir)s already exists but is not owned by %(owner)s."
NEWBASE_CHILDSUBDOMAIN_EXISTS = ((53L << 56) | (255L << 48)) | 47; errors[((53L << 56) | (255L << 48)) | 47] = "Cannot move subdomain base directory to %(newbase)s because the directory %(subdir)s to be used by the subdomain %(sub)s already exists."
HOOK_SCRIPT_FAILED = ((53L << 56) | (255L << 48)) | 48; errors[((53L << 56) | (255L << 48)) | 48] = "The external hook script %(script)s returned an error status %(ret)s."
UPLOAD_SERVICES_NOT_ENABLED = ((53L << 56) | (255L << 48)) | 49; errors[((53L << 56) | (255L << 48)) | 49] = "You will not be able to upload content to your subdomain without FTP/telnet/ssh access."
COMMON_PREFIX = ((53L << 56) | (255L << 48)) | 50; errors[((53L << 56) | (255L << 48)) | 50] = "Cannot use '%(path)s' as the document root, because it lies within the document root '%(matching_path)s' of another subdomain '%(child)s'"
UNABLE_WILDCARD = ((53L << 56) | (255L << 48)) | 51; errors[((53L << 56) | (255L << 48)) | 51] = "Cannot enable subdomain wildcards for this domain, because the pattern '%(pattern)s' conflicts with '%(conflict)s', which is a %(kind)s that belongs to %(reservedby)s."
UNABLE_OBTAIN_LOCK = ((53L << 56) | (255L << 48)) | 52; errors[((53L << 56) | (255L << 48)) | 52] = "Unable to obtain subdomain operation lock !"
UNABLE_RESERVE_SUBDOMAIN = ((53L << 56) | (255L << 48)) | 53; errors[((53L << 56) | (255L << 48)) | 53] = "Unable to reserve the subdomain name '%(name)s' because the %(kind)s '%(what)s' already belongs to '%(reservedby)s'."
DOCROOT_OUTSIDE_BASE_HOME = ((53L << 56) | (255L << 48)) | 54; errors[((53L << 56) | (255L << 48)) | 54] = "Invalid subdomain document root '%(document_root)s'! It must lie withing the subdomain base directory (%(base)s), or within the home directory of the subdomain owner, i.e. /home/[owner]/"
UNABLE_RENAME_BASE = ((53L << 56) | (255L << 48)) | 55; errors[((53L << 56) | (255L << 48)) | 55] = "Unable to change the subdomain base directory to '%(new)s' because the subdomains %(existing)s already have their document root within the base directory '%(old)s'"
UNABLE_RESERVE_SUBDOMAIN_IMPORT = ((53L << 56) | (255L << 48)) | 56; errors[((53L << 56) | (255L << 48)) | 56] = "Unable to create the subdomain '%(name)s' because the %(kind)s '%(what)s' already belongs to '%(reservedby)s'."
SKIPPING_SUBDOMAIN_IMPORT = ((53L << 56) | (255L << 48)) | 57; errors[((53L << 56) | (255L << 48)) | 57] = "Skipping subdomain import: %(name)s"
BASEDIR_WITHIN_SYMLINK = ((53L << 56) | (255L << 48)) | 58; errors[((53L << 56) | (255L << 48)) | 58] = "Cannot use '%(base)s' as the base directory, because it lies within the directory '%(symlink_base)s', which is reserved for use by WEBppliance"
SITEUSER_CANNOT_IMPORT_SUBDOMAINS = ((53L << 56) | (255L << 48)) | 59; errors[((53L << 56) | (255L << 48)) | 59] = "Site user cannot import subdomains. The subdomains belonging to this user will not be re-created."
TOOMANY_IMPORT = ((53L << 56) | (255L << 48)) | 60; errors[((53L << 56) | (255L << 48)) | 60] = "Skipping import of subdomain %(name)s, because the maximum subdomain limit for this site has been reached."
UNABLE_IMPORT_SUBDOMAINS = ((53L << 56) | (255L << 48)) | 61; errors[((53L << 56) | (255L << 48)) | 61] = "Unable to import subdomains. Unspecified Error. Please refer to the error log for details."
NOT_ALLOWED_CHARS = ((53L << 56) | (255L << 48)) | 62; errors[((53L << 56) | (255L << 48)) | 62] = "Subdomain name %(subdomain)s contains invalid characters - only letters, numbers, - and . are allowed."
